// PPgGeneral.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "SearchDlg.h"
#include "KademliaWnd.h"
#include "PreferencesDlg.h"
#include "PPgGeneral.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


// CPPgGeneral dialog

IMPLEMENT_DYNAMIC(CPPgGeneral, CPreferencesPage)	// [TPT] - SLUGFILLER: modelessDialogs
CPPgGeneral::CPPgGeneral()
	: CPreferencesPage(CPPgGeneral::IDD)	// [TPT] - SLUGFILLER: modelessDialogs
{
}

CPPgGeneral::~CPPgGeneral()
{
}

void CPPgGeneral::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);

	// added by [TPT]-MoNKi [MoNKi: -invisible mode-]
	DDX_Control(pDX, IDC_KEYMODCOMBO, m_invmode_keymodifiers);
	DDX_Control(pDX, IDC_KEYCOMBO, m_invmode_keys);
	// End [TPT]-MoNKi

	DDX_Control(pDX, IDC_LANGS, m_language);
}


BEGIN_MESSAGE_MAP(CPPgGeneral, CPreferencesPage)	// [TPT] - SLUGFILLER: modelessDialogs
	ON_BN_CLICKED(IDC_STARTMIN, OnSettingsChange)
	ON_EN_CHANGE(IDC_NICK, OnSettingsChange)
	ON_BN_CLICKED(IDC_BEEPER, OnSettingsChange)
	ON_BN_CLICKED(IDC_EXIT, OnSettingsChange)
	ON_BN_CLICKED(IDC_SPLASHON, OnSettingsChange)
	ON_BN_CLICKED(IDC_BRINGTOFOREGROUND, OnSettingsChange)
	ON_CBN_SELCHANGE(IDC_LANGS, OnSettingsChange)
	ON_BN_CLICKED(IDC_ED2KFIX, OnBnClickedEd2kfix)
	ON_BN_CLICKED(IDC_WEBSVEDIT , OnBnClickedEditWebservices)
	ON_BN_CLICKED(IDC_ONLINESIG, OnSettingsChange)
	ON_BN_CLICKED(IDC_CHECK4UPDATE, OnSettingsChange)
	// emulEspaa: added by [TPT]-MoNKi [MoNKi: -invisible mode-]
	ON_CBN_SELCHANGE(IDC_KEYCOMBO, OnSettingsChange)
	ON_CBN_SELCHANGE(IDC_KEYMODCOMBO, OnCbnSelchangeKeymodcombo)
	ON_BN_CLICKED(IDC_INVISIBLEMODE, OnBnClickedInvisiblemode)
	// End [TPT]-MoNKi
	ON_WM_HSCROLL()
END_MESSAGE_MAP()

void CPPgGeneral::LoadSettings(void)
{
	GetDlgItem(IDC_NICK)->SetWindowText(app_prefs->prefs->nick);

	for(int i = 0; i < m_language.GetCount(); i++)
		if(m_language.GetItemData(i) == app_prefs->GetLanguageID())
			m_language.SetCurSel(i);
	
	if(app_prefs->prefs->startMinimized)
		CheckDlgButton(IDC_STARTMIN,1);
	else
		CheckDlgButton(IDC_STARTMIN,0);

	if (app_prefs->prefs->onlineSig)
		CheckDlgButton(IDC_ONLINESIG,1);
	else
		CheckDlgButton(IDC_ONLINESIG,0);
	
	if(app_prefs->prefs->beepOnError)
		CheckDlgButton(IDC_BEEPER,1);
	else
		CheckDlgButton(IDC_BEEPER,0);

	if(app_prefs->prefs->confirmExit)
		CheckDlgButton(IDC_EXIT,1);
	else
		CheckDlgButton(IDC_EXIT,0);

	if(app_prefs->prefs->splashscreen)
		CheckDlgButton(IDC_SPLASHON,1);
	else
		CheckDlgButton(IDC_SPLASHON,0);

	if(app_prefs->prefs->bringtoforeground)
		CheckDlgButton(IDC_BRINGTOFOREGROUND,1);
	else
		CheckDlgButton(IDC_BRINGTOFOREGROUND,0);

	if(app_prefs->prefs->updatenotify)
		CheckDlgButton(IDC_CHECK4UPDATE,1);
	else
		CheckDlgButton(IDC_CHECK4UPDATE,0);

	// Added by [TPT]-MoNKi [MoNKi: -invisible mode-]
	m_iActualKeyModifier = app_prefs->GetInvisibleModeHKKeyModifier();
	m_invmode_keys.SelectString(-1, CString(app_prefs->GetInvisibleModeHKKey()));
	if (!app_prefs->GetInvisibleMode()){
		CStatic *plusLabel = (CStatic *)GetDlgItem(IDC_PLUSLABEL);
		CStatic *hkLabel = (CStatic *)GetDlgItem(IDC_HOTKEYLABEL);
		CStatic *hkmodLabel = (CStatic *)GetDlgItem(IDC_KEYMODLABEL);
		CStatic *hkkeyLabel = (CStatic *)GetDlgItem(IDC_KEYLABEL);
		plusLabel->EnableWindow(FALSE);
		hkLabel->EnableWindow(FALSE);
		hkmodLabel->EnableWindow(FALSE);
		hkkeyLabel->EnableWindow(FALSE);
		m_invmode_keymodifiers.EnableWindow(FALSE);
		m_invmode_keys.EnableWindow(FALSE);
		CheckDlgButton(IDC_INVISIBLEMODE, 0);
	} else 
		CheckDlgButton(IDC_INVISIBLEMODE, 1);
	// End [TPT]-MoNKi


	CString strBuffer;
	strBuffer.Format("%i %s",app_prefs->prefs->versioncheckdays ,GetResString(IDS_DAYS2));
	GetDlgItem(IDC_DAYS)->SetWindowText(strBuffer);
}

BOOL CPPgGeneral::OnInitDialog()
{
	CPropertyPage::OnInitDialog();
	InitWindowStyles(this);

	((CEdit*)GetDlgItem(IDC_NICK))->SetLimitText(MAX_NICK_LENGTH);

	CWordArray aLanguageIDs;
	app_prefs->GetLanguages(aLanguageIDs);
	for (int i = 0; i < aLanguageIDs.GetSize(); i++){
		TCHAR szLang[128];
		GetLocaleInfo(aLanguageIDs[i], LOCALE_SLANGUAGE, szLang, ARRSIZE(szLang));
		m_language.SetItemData(m_language.AddString(szLang), aLanguageIDs[i]);
	}

	GetDlgItem(IDC_ED2KFIX)->EnableWindow(Ask4RegFix(true));

	CSliderCtrl *sliderUpdate = (CSliderCtrl*)GetDlgItem(IDC_CHECKDAYS);
	sliderUpdate->SetRange(2, 7, true);
	sliderUpdate->SetPos(app_prefs->GetUpdateDays());

	// added by [TPT]-MoNKi [MoNKi: -invisible mode-]
	// Add keys to ComboBox
	for(int i='A'; i<='Z'; i++)
		m_invmode_keys.AddString(_T(CString((char)(i))));
	for(int i='0'; i<='9'; i++)
		m_invmode_keys.AddString(_T(CString((char)(i))));
	// End [TPT]-MoNKi

	LoadSettings();
	Localize();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CPPgGeneral::OnApply()
{
	if(GetDlgItem(IDC_NICK)->GetWindowTextLength())
	{
		// [TPT] - itsonlyme: viewSharedFiles
		CString userNick;
		GetDlgItem(IDC_NICK)->GetWindowText(userNick);
		theApp.glob_prefs->SetUserNick(userNick);
		// [TPT] - itsonlyme: viewSharedFiles
	}
	if (m_language.GetCurSel() != CB_ERR){
		WORD byNewLang =  m_language.GetItemData(m_language.GetCurSel());
		if (app_prefs->GetLanguageID() != byNewLang){
			app_prefs->SetLanguageID(byNewLang);
		
			theApp.glob_prefs->SetLanguage();

			theApp.emuledlg->preferenceswnd->Localize();
			theApp.emuledlg->statisticswnd.CreateMyTree();
			theApp.emuledlg->statisticswnd.Localize();
			theApp.emuledlg->statisticswnd.ShowStatistics(true);
			theApp.emuledlg->serverwnd.Localize();
			theApp.emuledlg->transferwnd.Localize();
			theApp.emuledlg->transferwnd.UpdateCatTabTitles();
			theApp.emuledlg->searchwnd->Localize();
			theApp.emuledlg->sharedfileswnd.Localize();
			theApp.emuledlg->chatwnd.Localize();
			theApp.emuledlg->Localize();
			theApp.emuledlg->ircwnd.Localize();
			theApp.emuledlg->kademliawnd->Localize();
		}
	}

	app_prefs->prefs->startMinimized= (int8)IsDlgButtonChecked(IDC_STARTMIN);
	app_prefs->prefs->beepOnError= (int8)IsDlgButtonChecked(IDC_BEEPER);
	app_prefs->prefs->confirmExit= (int8)IsDlgButtonChecked(IDC_EXIT);
	app_prefs->prefs->splashscreen = (int8)IsDlgButtonChecked(IDC_SPLASHON);
	app_prefs->prefs->bringtoforeground = (int8)IsDlgButtonChecked(IDC_BRINGTOFOREGROUND);
	app_prefs->prefs->updatenotify = (int8)IsDlgButtonChecked(IDC_CHECK4UPDATE);
	app_prefs->prefs->onlineSig= (int8)IsDlgButtonChecked(IDC_ONLINESIG);
	app_prefs->prefs->versioncheckdays = ((CSliderCtrl*)GetDlgItem(IDC_CHECKDAYS))->GetPos();

	// Added by [TPT]-MoNKi [MoNKi: -invisible mode-]
	CString sKey;
	m_invmode_keys.GetLBText(m_invmode_keys.GetCurSel(), sKey);
	if (IsDlgButtonChecked(IDC_INVISIBLEMODE))
		app_prefs->SetInvisibleMode(true,m_iActualKeyModifier,sKey[0]);
	else
		app_prefs->SetInvisibleMode(false,m_iActualKeyModifier,sKey[0]);
	// End [TPT]-MoNKi

	theApp.emuledlg->transferwnd.downloadlistctrl.SetStyle();
	LoadSettings();

	SetModified(FALSE);
	return CPropertyPage::OnApply();
}

void CPPgGeneral::OnBnClickedEd2kfix()
{
	Ask4RegFix(false);
	GetDlgItem(IDC_ED2KFIX)->EnableWindow(Ask4RegFix(true));
}

void CPPgGeneral::Localize(void)
{
	if(m_hWnd)
	{
		SetWindowText(GetResString(IDS_PW_GENERAL));
		GetDlgItem(IDC_NICK_FRM)->SetWindowText(GetResString(IDS_PW_NICK));
		GetDlgItem(IDC_LANG_FRM)->SetWindowText(GetResString(IDS_PW_LANG));
		GetDlgItem(IDC_MISC_FRM)->SetWindowText(GetResString(IDS_PW_MISC));
		GetDlgItem(IDC_BEEPER)->SetWindowText(GetResString(IDS_PW_BEEP));
		GetDlgItem(IDC_EXIT)->SetWindowText(GetResString(IDS_PW_PROMPT));
		GetDlgItem(IDC_SPLASHON)->SetWindowText(GetResString(IDS_PW_SPLASH));
		GetDlgItem(IDC_BRINGTOFOREGROUND)->SetWindowText(GetResString(IDS_PW_FRONT));
		GetDlgItem(IDC_ONLINESIG)->SetWindowText(GetResString(IDS_PREF_ONLINESIG));	
		GetDlgItem(IDC_STARTMIN)->SetWindowText(GetResString(IDS_PREF_STARTMIN));	
		GetDlgItem(IDC_WEBSVEDIT)->SetWindowText(GetResString(IDS_WEBSVEDIT));
		GetDlgItem(IDC_ED2KFIX)->SetWindowText(GetResString(IDS_ED2KLINKFIX));
		GetDlgItem(IDC_CHECK4UPDATE)->SetWindowText(GetResString(IDS_CHECK4UPDATE));
		GetDlgItem(IDC_STARTUP)->SetWindowText(GetResString(IDS_STARTUP));

		// Added by [TPT]-MoNKi [MoNKi: -invisible mode-]
		// Add key modifiers to ComboBox
		m_invmode_keymodifiers.ResetContent();
		m_invmode_keymodifiers.AddString(GetResString(IDS_CTRLKEY));
		m_invmode_keymodifiers.AddString(GetResString(IDS_ALTKEY));
		m_invmode_keymodifiers.AddString(GetResString(IDS_SHIFTKEY));
		m_invmode_keymodifiers.AddString(GetResString(IDS_CTRLKEY) + " + " + GetResString(IDS_ALTKEY));
		m_invmode_keymodifiers.AddString(GetResString(IDS_CTRLKEY) + " + " + GetResString(IDS_SHIFTKEY));
		m_invmode_keymodifiers.AddString(GetResString(IDS_ALTKEY) + " + " + GetResString(IDS_SHIFTKEY));
		m_invmode_keymodifiers.AddString(GetResString(IDS_CTRLKEY) + " + " + GetResString(IDS_ALTKEY) + " + " + GetResString(IDS_SHIFTKEY));

		CString key_modifier;
		if (m_iActualKeyModifier & MOD_CONTROL)
			key_modifier=GetResString(IDS_CTRLKEY);
		if (m_iActualKeyModifier & MOD_ALT){
			if (!key_modifier.IsEmpty()) key_modifier += " + ";
			key_modifier+=GetResString(IDS_ALTKEY);
		}
		if (m_iActualKeyModifier & MOD_SHIFT){
			if (!key_modifier.IsEmpty()) key_modifier += " + ";
			key_modifier+=GetResString(IDS_SHIFTKEY);
		}
		m_invmode_keymodifiers.SelectString(-1,key_modifier);
		
		GetDlgItem(IDC_INVMODEGROUP)->SetWindowText(GetResString(IDS_INVMODE_GROUP));
		GetDlgItem(IDC_INVISIBLEMODE)->SetWindowText(GetResString(IDS_INVMODE));
		GetDlgItem(IDC_HOTKEYLABEL)->SetWindowText(GetResString(IDS_INVMODE_HOTKEY));
		GetDlgItem(IDC_KEYMODLABEL)->SetWindowText(GetResString(IDS_INVMODE_MODKEY));
		GetDlgItem(IDC_KEYLABEL)->SetWindowText(GetResString(IDS_INVMODE_VKEY));
		// End [TPT]-MoNKi

	}
}

void CPPgGeneral::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	SetModified(TRUE);

	if (pScrollBar==GetDlgItem(IDC_CHECKDAYS)) {
		CSliderCtrl* slider =(CSliderCtrl*)pScrollBar;
		CString text;
		text.Format("%i %s",slider->GetPos(),GetResString(IDS_DAYS2));
		GetDlgItem(IDC_DAYS)->SetWindowText(text);
	}

	UpdateData(false); 
	CPropertyPage::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CPPgGeneral::OnBnClickedEditWebservices(){
	ShellExecute(NULL, "open", theApp.glob_prefs->GetTxtEditor(), "\""+CString(theApp.glob_prefs->GetConfigDir())+"webservices.dat\"", NULL, SW_SHOW); 
}

// added by [TPT]-MoNKi [MoNKi: -invisible mode-]
void CPPgGeneral::OnBnClickedInvisiblemode()
{
	CStatic *plusLabel = (CStatic *)GetDlgItem(IDC_PLUSLABEL);
	CStatic *hkLabel = (CStatic *)GetDlgItem(IDC_HOTKEYLABEL);
	CStatic *hkmodLabel = (CStatic *)GetDlgItem(IDC_KEYMODLABEL);
	CStatic *hkkeyLabel = (CStatic *)GetDlgItem(IDC_KEYLABEL);
	if(IsDlgButtonChecked(IDC_INVISIBLEMODE)){
		plusLabel->EnableWindow(TRUE);
		hkLabel->EnableWindow(TRUE);
		hkmodLabel->EnableWindow(TRUE);
		hkkeyLabel->EnableWindow(TRUE);
		m_invmode_keymodifiers.EnableWindow(TRUE);
		m_invmode_keys.EnableWindow(TRUE);
	} else {
		plusLabel->EnableWindow(FALSE);
		hkLabel->EnableWindow(FALSE);
		hkmodLabel->EnableWindow(FALSE);
		hkkeyLabel->EnableWindow(FALSE);
		m_invmode_keymodifiers.EnableWindow(FALSE);
		m_invmode_keys.EnableWindow(FALSE);
	}
	SetModified();
}

void CPPgGeneral::OnCbnSelchangeKeymodcombo()
{
	CString sKeyMod;
	
	m_invmode_keymodifiers.GetLBText(m_invmode_keymodifiers.GetCurSel(), sKeyMod);
	m_iActualKeyModifier = 0;
	if (sKeyMod.Find(GetResString(IDS_CTRLKEY))!=-1)
		m_iActualKeyModifier |= MOD_CONTROL;
	if (sKeyMod.Find(GetResString(IDS_ALTKEY))!=-1)
		m_iActualKeyModifier |= MOD_ALT;
	if (sKeyMod.Find(GetResString(IDS_SHIFTKEY))!=-1)
		m_iActualKeyModifier |= MOD_SHIFT;
	
	SetModified();
}
// End [TPT]-MoNKi
