// itsonlyme:reqFiles START
//this file is part of eMule
// added by itsonlyme
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include "stdafx.h" 
#include "emule.h"
#include "ReqFiles.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


///////////////////////////////////////////////////////////////////////////////
// CReqFilesPage

IMPLEMENT_DYNAMIC(CReqFilesPage, CResizablePage) 

BEGIN_MESSAGE_MAP(CReqFilesPage, CResizablePage) 
   ON_BN_CLICKED(IDCOK, OnBnClickedApply) 
   ON_BN_CLICKED(IDCREF, OnBnClickedRefresh) 
END_MESSAGE_MAP() 

CReqFilesPage::CReqFilesPage() 
   : CResizablePage(CReqFilesPage::IDD)
{ 
	m_strCaption = GetResString(IDS_REQUESTED_FILES);
	m_psp.pszTitle = m_strCaption;
	m_psp.dwFlags |= PSP_USETITLE;
	m_client = NULL; 
} 

CReqFilesPage::~CReqFilesPage() 
{ 
} 

void CReqFilesPage::DoDataExchange(CDataExchange* pDX) 
{ 
	CResizablePage::DoDataExchange(pDX); 
	DDX_Control(pDX, IDC_LST, pmyListCtrl);
} 

void CReqFilesPage::OnBnClickedApply() 
{ 
	CResizablePage::OnOK(); 
} 

void CReqFilesPage::OnBnClickedRefresh() 
{ 
	CompleteFileList(); 
} 

BOOL CReqFilesPage::OnInitDialog()
{ 
	CResizablePage::OnInitDialog(); 
	InitWindowStyles(this);

	AddAnchor(IDC_LST,TOP_LEFT,BOTTOM_RIGHT);
	AddAnchor(IDCREF,BOTTOM_RIGHT);
	AddAnchor(IDC_CMSTATUS,BOTTOM_LEFT);

	Localize();
	
	pmyListCtrl.InsertColumn(0, GetResString(IDS_DL_FILENAME), LVCFMT_LEFT, 360, -1); 
	pmyListCtrl.InsertColumn(1, GetResString(IDS_STATUS), LVCFMT_LEFT, 140, -1); 

	CompleteFileList();
	return TRUE; 
} 

void CReqFilesPage::Localize(void)
{ 
	GetDlgItem(IDCREF)->SetWindowText(GetResString(IDS_CMT_REFRESH));
	if (theApp.clientlist->IsValidClient(m_client))
		m_strCaption = GetResString(IDS_REQUESTED_FILES) + m_client->GetUserName();
	else
		m_strCaption = GetResString(IDS_REQUESTED_FILES);
	m_psp.pszTitle = m_strCaption;
} 

void CReqFilesPage::CompleteFileList() {
	int count=0; 
	pmyListCtrl.DeleteAllItems();
	if (!theApp.clientlist->IsValidClient(m_client)) return;

	if (theApp.downloadqueue->IsPartFile(m_client->reqfile))
	{
		pmyListCtrl.InsertItem(count,m_client->reqfile->GetFileName());
		if (m_client->GetDownloadState() == DS_DOWNLOADING)
			pmyListCtrl.SetItemText(count, 1, GetResString(IDS_DOWNLOADING));
		else
			pmyListCtrl.SetItemText(count, 1, GetResString(IDS_WAITING));
		count++;
	}
	for(POSITION pos = m_client->m_OtherRequests_list.GetHeadPosition();pos!=0;m_client->m_OtherRequests_list.GetNext(pos))
	{
		pmyListCtrl.InsertItem(count,m_client->m_OtherRequests_list.GetAt(pos)->GetFileName());
		pmyListCtrl.SetItemText(count, 1, GetResString(IDS_ASKED4ANOTHERFILE)); 
		count++;
	}
	for(POSITION pos = m_client->m_OtherNoNeeded_list.GetHeadPosition();pos!=0;m_client->m_OtherNoNeeded_list.GetNext(pos))
	{
		pmyListCtrl.InsertItem(count,m_client->m_OtherNoNeeded_list.GetAt(pos)->GetFileName());
		pmyListCtrl.SetItemText(count, 1, GetResString(IDS_NONEEDEDPARTS)); 
		count++;
	}

	CString info;
	if (count==0) 
		info=GetResString(IDS_DOWNFILES_NONE);
	else
		info.Format(GetResString(IDS_DOWNFILES_COUNT), count);
	GetDlgItem(IDC_CMSTATUS)->SetWindowText(info);
}

// itsonlyme:reqFiles END
